﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace CSharpServer
{
    public partial class Form1 : Form
    {
        UInt32[] TagHandle = new UInt32[100];
        WtOPCsvr_Library.WtOPCsvr_DLL.WriteNotificationDelegate WriteCallback;

        public Form1()
        {
            InitializeComponent();
            WriteCallback = new WtOPCsvr_Library.WtOPCsvr_DLL.WriteNotificationDelegate(MyWriteCallback);
        }

        public void MyWriteCallback(UInt32 hItem, ref Object Value, ref UInt32 ResultCode)
        {
            ResultCode = 0;
		    if (hItem == TagHandle[0])
            {
                textBox1.Text = Convert.ToString (Value);
                WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[0], textBox1.Text, 192);
            }
            if (hItem == TagHandle[1])
            {
                textBox2.Text = Convert.ToString(Value);
                WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[1], textBox2.Text, 192);
            }
            if (hItem == TagHandle[2])
            {
                textBox3.Text = Convert.ToString(Value);
                WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[2], textBox3.Text, 192);
            }
            if (hItem == TagHandle[3])
            {
                textBox4.Text = Convert.ToString(Value);
                WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[3], textBox4.Text, 192);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string exepath;

            exepath = Application.StartupPath + "\\CSharpServer.exe";

            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateRegistry("{57E9743C-0678-419c-B28B-7508417DAC8C}",
                                        "CSharpServer",
                                        "C# Example OPC Server",
                                        exepath);

        }

        private void button2_Click(object sender, EventArgs e)
        {
		    //Initialize WtOPCSvr
            WtOPCsvr_Library.WtOPCsvr_DLL.SetVendorInfo("MY Company.Com");
            WtOPCsvr_Library.WtOPCsvr_DLL.InitWTOPCsvr("{57E9743C-0678-419c-B28B-7508417DAC8C}", 1000);

            WtOPCsvr_Library.WtOPCsvr_DLL.EnableWriteNotification(WriteCallback, true);
	
        }



        private void button6_Click(object sender, EventArgs e)
        {
            WtOPCsvr_Library.WtOPCsvr_DLL.UnregisterServer("{57E9743C-0678-419c-B28B-7508417DAC8C}",
                                "CSharpServer");

        }

        private void button3_Click(object sender, EventArgs e)
        {
            TagHandle[0] = WtOPCsvr_Library.WtOPCsvr_DLL.CreateTag("Tag.1", textBox1.Text, 192, true);
            TagHandle[1] = WtOPCsvr_Library.WtOPCsvr_DLL.CreateTag("Tag.2", textBox1.Text, 192, true);
            TagHandle[2] = WtOPCsvr_Library.WtOPCsvr_DLL.CreateTag("Tag.3", textBox1.Text, 192, true);
            TagHandle[3] = WtOPCsvr_Library.WtOPCsvr_DLL.CreateTag("Tag.4", textBox1.Text, 192, true);

        }

        private void button4_Click(object sender, EventArgs e)
        {
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[0], textBox1.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[1], textBox2.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[2], textBox3.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[3], textBox4.Text, 192);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            float temp;

            temp = Convert.ToSingle(textBox1.Text);
            textBox1.Text = Convert.ToString (temp + 1);
            temp = Convert.ToSingle (textBox2.Text);
            textBox2.Text = Convert.ToString (temp + 1);
            temp = Convert.ToSingle (textBox3.Text);
            textBox3.Text = Convert.ToString (temp + 1);
            temp = Convert.ToSingle (textBox4.Text);
            textBox4.Text = Convert.ToString (temp + 1);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[0], textBox1.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[1], textBox2.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[2], textBox3.Text, 192);
            WtOPCsvr_Library.WtOPCsvr_DLL.UpdateTag(TagHandle[3], textBox4.Text, 192);

        }

    }
}
